Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Botan::PK_Decryptor_EME Class Referencefinal

`#include <pubkey.h>`

Inheritance diagram for Botan::PK_Decryptor_EME:

## Public Member Functions
secure_vector< uint8_t > | decrypt (const uint8_t in[], size_t length) const
template<typename Alloc >
secure_vector< uint8_t > | decrypt (const std::vector< uint8_t, Alloc > &in) const
secure_vector< uint8_t > | decrypt_or_random (const uint8_t in[], size_t length, size_t expected_pt_len, RandomNumberGenerator &rng) const
secure_vector< uint8_t > | decrypt_or_random (const uint8_t in[], size_t length, size_t expected_pt_len, RandomNumberGenerator &rng, const uint8_t required_content_bytes[], const uint8_t required_content_offsets[], size_t required_contents) const
PK_Decryptor_EME & | operator= (const PK_Decryptor_EME &)=delete
| PK_Decryptor_EME (const Private_Key &key, RandomNumberGenerator &rng, const std::string &eme, const std::string &provider="")
| PK_Decryptor_EME (const PK_Decryptor_EME &)=delete
| ~PK_Decryptor_EME ()

## Detailed Description

Decryption with an MR algorithm and an EME.

Definition at line 554 of file pubkey.h.

## Constructor & Destructor Documentation

Botan::PK_Decryptor_EME::PK_Decryptor_EME | ( | const Private_Key & | key,
|  | RandomNumberGenerator & | rng,
|  | const std::string & | eme,
|  | const std::string & | provider = `""`
| ) |  |

Construct an instance.

Parameters

  key | the key to use inside the decryptor
  rng | the random generator to use
  eme | the EME to use
  provider | the provider to use

Definition at line 109 of file pubkey.cpp.

References Botan::Public_Key::algo_name(), and Botan::Private_Key::create_decryption_op().

113 {
114 m_op = key.create_decryption_op(rng, padding, provider);
115 if(!m_op)
116 throw Invalid_Argument("Key type " + key.algo_name() + " does not support decryption");
117 }

Botan::PK_Decryptor_EME::~PK_Decryptor_EME | ( |  | ) |

Definition at line 119 of file pubkey.cpp.

119 { /* for unique_ptr */ }

Botan::PK_Decryptor_EME::PK_Decryptor_EME | ( | const PK_Decryptor_EME & |  | ) |
| delete

## Member Function Documentation

secure_vector< uint8_t > Botan::PK_Decryptor::decrypt | ( | const uint8_t | in[],
|  | size_t | length
| ) |  | const
| inherited

Decrypt a ciphertext, throwing an exception if the input seems to be invalid (eg due to an accidental or malicious error in the ciphertext).

Parameters

  in | the ciphertext as a byte array
  length | the length of the above byte array

Returns
  decrypted message

Definition at line 16 of file pubkey.cpp.

Referenced by Botan::KeyPair::encryption_consistency_check().

17 {
18 uint8_t valid_mask = 0;
19
20 secure_vector<uint8_t> decoded = do_decrypt(valid_mask, in, length);
21
22 if(valid_mask == 0)
23 throw Decoding_Error("Invalid public key ciphertext, cannot decrypt");
24
25 return decoded;
26 }
template<typename Alloc >

secure_vector<uint8_t> Botan::PK_Decryptor::decrypt | ( | const std::vector< uint8_t, Alloc > & | in | ) | const
| inline inherited

Same as above, but taking a vector

Parameters

  in | the ciphertext

Returns
  decrypted message

Definition at line 105 of file pubkey.h.

References Botan::CryptoBox::decrypt().

106 {
107 return decrypt(in.data(), in.size());
108 }
Botan::PK_Decryptor::decrypt
secure_vector< uint8_t > decrypt(const uint8_t in[], size_t length) const
Definition: pubkey.cpp:16

secure_vector< uint8_t > Botan::PK_Decryptor::decrypt_or_random | ( | const uint8_t | in[],
|  | size_t | length,
|  | size_t | expected_pt_len,
|  | RandomNumberGenerator & | rng
| ) |  | const
| inherited

Decrypt a ciphertext. If the ciphertext is invalid (eg due to invalid padding) or is not the expected length, instead returns a random string of the expected length. Use to avoid oracle attacks, especially against PKCS #1 v1.5 decryption.

Definition at line 77 of file pubkey.cpp.

81 {
82 return decrypt_or_random(in, length, expected_pt_len, rng,
83 nullptr, nullptr, 0);
84 }
Botan::PK_Decryptor::decrypt_or_random
secure_vector< uint8_t > decrypt_or_random(const uint8_t in[], size_t length, size_t expected_pt_len, RandomNumberGenerator &rng) const
Definition: pubkey.cpp:77

secure_vector< uint8_t > Botan::PK_Decryptor::decrypt_or_random | ( | const uint8_t | in[],
|  | size_t | length,
|  | size_t | expected_pt_len,
|  | RandomNumberGenerator & | rng,
|  | const uint8_t | required_content_bytes[],
|  | const uint8_t | required_content_offsets[],
|  | size_t | required_contents
| ) |  | const
| inherited

Decrypt a ciphertext. If the ciphertext is invalid (eg due to invalid padding) or is not the expected length, instead returns a random string of the expected length. Use to avoid oracle attacks, especially against PKCS #1 v1.5 decryption.

Additionally checks (also in const time) that: contents[required_content_offsets[i]] == required_content_bytes[i] for 0 <= i < required_contents

Used for example in TLS, which encodes the client version in the content bytes: if there is any timing variation the version check can be used as an oracle to recover the key.

Definition at line 29 of file pubkey.cpp.

References BOTAN_ASSERT, Botan::CT::conditional_copy_mem(), Botan::CT::is_equal(), and Botan::RandomNumberGenerator::random_vec().

36 {
37 const secure_vector<uint8_t> fake_pms = rng.random_vec(expected_pt_len);
38
39 uint8_t valid_mask = 0;
40 secure_vector<uint8_t> decoded = do_decrypt(valid_mask, in, length);
41
42 valid_mask &= CT::is_equal(decoded.size(), expected_pt_len);
43
44 decoded.resize(expected_pt_len);
45
46 for(size_t i = 0; i != required_contents_length; ++i)
47 {
48 /*
49 These values are chosen by the application and for TLS are constants,
50 so this early failure via assert is fine since we know 0,1 < 48
51
52 If there is a protocol that has content checks on the key where
53 the expected offsets are controllable by the attacker this could
54 still leak.
55
56 Alternately could always reduce the offset modulo the length?
57 */
58
59 const uint8_t exp = required_content_bytes[i];
60 const uint8_t off = required_content_offsets[i];
61
62 BOTAN_ASSERT(off < expected_pt_len, "Offset in range of plaintext");
63
64 valid_mask &= CT::is_equal(decoded[off], exp);
65 }
66
67 CT::conditional_copy_mem(valid_mask,
68 /*output*/decoded.data(),
69 /*from0*/decoded.data(),
70 /*from1*/fake_pms.data(),
71 expected_pt_len);
72
73 return decoded;
74 }
Botan::CT::conditional_copy_mem
void conditional_copy_mem(T value, T *to, const T *from0, const T *from1, size_t elems)
Definition: ct_utils.h:138
Botan::CT::is_equal
T is_equal(T x, T y)
Definition: ct_utils.h:116
BOTAN_ASSERT
#define BOTAN_ASSERT(expr, assertion_made)
Definition: assert.h:27

PK_Decryptor_EME& Botan::PK_Decryptor_EME::operator= | ( | const PK_Decryptor_EME & |  | ) |
| delete

The documentation for this class was generated from the following files:

- src/lib/pubkey/pubkey.h
- src/lib/pubkey/pubkey.cpp